#include <bindings-gobject.dsl.h>
#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

{-

  This code writes FFI to GTK+, using bindings-DSL and
  bindings-gobject hsc2hs macro sets:

  http://hackage.haskell.org/package/bindings-DSL
  http://hackage.haskell.org/package/bindings-gobject

-}

module GtkGdk where
#strict_import
import Bindings.GLib
import Bindings.GObject

#num GDK_1
#num GDK_2
#num GDK_e
#num GDK_p
#num GDK_q
#integral_t GdkModifierType

#integral_t PangoEllipsizeMode
#num PANGO_ELLIPSIZE_MIDDLE

#standard_macros GTK , WINDOW , GtkWindow
#standard_macros GTK , WIDGET , GtkWidget
#standard_macros GTK , LABEL , GtkLabel
#standard_macros GTK , TABLE , GtkTable
#standard_macros GTK , CONTAINER , GtkContainer
#standard_macros GTK , ACCEL_GROUP , GtkAccelGroup

#integral_t GtkJustification
#num GTK_JUSTIFY_CENTER
#num GTK_JUSTIFY_FILL

#ccall gtk_init , Ptr CInt -> Ptr (Ptr (Ptr CChar)) -> IO ()
#ccall gtk_main , IO ()
#ccall gtk_main_quit , IO ()

#integral_t GtkWindowType
#num GTK_WINDOW_TOPLEVEL
#ccall gtk_window_new , <GtkWindowType> -> IO (Ptr <GtkWidget>)
#ccall gtk_window_set_title , Ptr <GtkWindow> -> Ptr <gchar> -> IO ()
#ccall gtk_window_add_accel_group , Ptr <GtkWindow> -> Ptr <GtkAccelGroup> -> IO ()

#ccall gtk_widget_show , Ptr <GtkWidget> -> IO ()

#ccall gtk_label_new , Ptr <gchar> -> IO (Ptr <GtkWidget>)
#ccall gtk_label_set_markup , Ptr <GtkLabel> -> Ptr <gchar> -> IO ()
#ccall gtk_label_set_justify , Ptr <GtkLabel> -> <GtkJustification> -> IO ()
#ccall gtk_label_set_ellipsize , Ptr <GtkLabel> -> <PangoEllipsizeMode> -> IO ()
#ccall gtk_label_set_line_wrap , Ptr <GtkLabel> -> <gboolean> -> IO ()

#ccall gtk_table_new , <guint> -> <guint> -> <gboolean> -> IO (Ptr <GtkWidget>)
#ccall gtk_table_attach_defaults , Ptr <GtkTable> -> Ptr <GtkWidget> -> \
    <guint> -> <guint> -> <guint> -> <guint> -> IO ()

#ccall gtk_container_add , Ptr <GtkContainer> -> Ptr <GtkWidget> -> IO ()

#integral_t GtkAccelFlags
#ccall gtk_accel_group_new , IO (Ptr <GtkAccelGroup>)
#ccall gtk_accel_group_connect , Ptr <GtkAccelGroup> -> <guint> -> \
    <GdkModifierType> -> <GtkAccelFlags> -> Ptr <GClosure> -> IO ()
#callback GtkAccelGroupActivate , Ptr <GtkAccelGroup> -> Ptr <GObject> -> \
    <guint> -> <GdkModifierType> -> IO <gboolean>

